/*****************************************************************************/
/* main.h : Donnes globales et fentre principale
 * main.h : Global data and main window
 *
 *
 * Greffon ToutDoux : Rseau
 * ToutDoux's plug-in : Network
 * Copyright (c) 2001 Philippe Roy
 * Auteur - Author : Philippe Roy <ph_roy@toutdoux.org>
 *
 *
 * Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
 * sous les termes de la licence publique gnrale GNU telle qu'elle est publie par
 * la Free Software Foundation ; soit la version 2 de la licence, ou
 * (comme vous voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir qu'il sera utile,
 * mais SANS AUCUNE GARANTIE ; mme sans la garantie de
 * COMMERCIALIT ou d'ADQUATION A UN BUT PARTICULIER. Voir la
 * licence publique gnrale GNU pour plus de dtails.
 *
 * Vous devriez avoir reu une copie de la licence publique gnrale GNU
 * avec ce programme ; si ce n'est pas le cas, crivez  la Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/*****************************************************************************/

#include <toutdoux.h>

/*****************************************************************************/
/*** Module */
/*****************************************************************************/
GtkObject *plugins_about_def (void);
GtkObject *plugins_init (int mod_id, gchar *mod_name);
void plugins_refresh (GtkObject *mod, GtkObject *mod_canvas);
void plugins_symbol_def (GtkObject *mod_canvas);

/*****************************************************************************/
/*** Node haut niveau - Node high level */
/*****************************************************************************/
void add_link (GtkObject *mod_canvas, GList *row);
void remove_link (GtkObject *mod_canvas);
void add_node (GtkObject *mod_canvas, GList *row);
void remove_node (GtkObject *mod_canvas, GnomeCanvasGroup *item);

/*****************************************************************************/
/* Node bas niveau - Node low level */
/*****************************************************************************/
void link_setup (GtkObject *mod_canvas, GnomeCanvasItem *item);
void link_event (GnomeCanvasItem *item, GdkEvent *event, GtkObject *mod_canvas);
void node_setup (GtkObject *mod_canvas, GnomeCanvasItem *item);
void node_event (GnomeCanvasItem *item, GdkEvent *event, GtkObject *mod_canvas);

/*****************************************************************************/
/*** Etablis - Benchs */
/*****************************************************************************/
void plugins_bench_refresh (GtkObject *mod, GtkObject *mod_canvas);
void plugins_etabliste_refresh (GtkObject *mod, GtkObject *mod_canvas);
void plugins_bench_action (GtkObject *mod, gchar *value, gchar *table_field, int bench_id);
void plugins_etabliste_action (GtkObject *mod, gchar *value, gchar *table_field, int etabliste_id);

/*****************************************************************************/
/*** Fonction - Function */
/*****************************************************************************/
void plugins_function_action (GtkObject *mod);

/*****************************************************************************/
/*** Menu */
/*****************************************************************************/
void menu_def (GtkObject *mod);
void plugins_menu_refresh (GtkObject *mod, GtkObject *mod_canvas);
void plugins_menu_action (GtkObject *mod, int menu_id);
void plugins_menu_link_action (GtkObject *mod, int menu_id);
